if((%error = ForceRequiredAddOn("System_PTG")) == $Error::AddOn_Disabled)
	echo("\c4>>\c2P\c1T\c4G: \c0Force-enabled required add-on \c4System_PTG");
if(%error == $Error::AddOn_NotFound)
{
	error("ERROR: Event_PTG - required add-on System_PTG not found.");
	return;
}
else
{
	//Output Events
	registerOutputEvent("fxDTSBrick","PTG_ExecFunction","list Start 0 Halt 1 Clear 2 Clear-Save 3 ClearAll 4 ClearAll-Save 5 Purge 6 ClearSeedSaves 7 ClearAllSaves 8 SetAllStatic 9 SetAllNonStatic 10 SaveAll 11 ShowHideChunks 12",1);
	registerOutputEvent("fxDTSBrick","PTG_Condition","list ifRunning 0 ifClearing 1 ifHalting 2",1);
	registerOutputEvent("fxDTSBrick","PTG_ChangeSeed","int -9999999 99999999 1237" TAB "bool 0",1);
	registerOutputEvent("fxDTSBrick","PTG_LoadPreset","string 30 188" TAB "list None 0 Clear 1 Clear-Save 2 ClearAll 3 ClearAll-Save 4 Purge 5" TAB "string 7 40",1);
	registerOutputEvent("fxDTSBrick","PTG_ShowPosition","",1);
	
	//Input Events
	registerInputEvent("fxDTSBrick","onPTGCondTrue","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
	registerInputEvent("fxDTSBrick","onPTGCondFalse","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//INPUT EVENT HANDLING


function fxDTSBrick::PTG_Event_Input(%brick,%cond,%cl)
{
	$InputTarget_["Self"]   = %brick;
	$InputTarget_["Player"] = %cl.player;
	$InputTarget_["Client"] = %cl;

	if($Server::LAN)
		$InputTarget_["MiniGame"] = getMiniGameFromObject(%cl);
	else
	{
		if(getMiniGameFromObject(%brick) == getMiniGameFromObject(%cl))
			$InputTarget_["MiniGame"] = getMiniGameFromObject(%brick);
		else
			$InputTarget_["MiniGame"] = 0;
	}

	switch(%cond)
	{
		case true:
			%brick.processInputEvent("onPTGCondTrue",%cl);
		case false:
			%brick.processInputEvent("onPTGCondFalse",%cl);
	}								
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//OUTPUT EVENT FUNCTIONS


function fxDTSBrick::PTG_ExecFunction(%brick,%func,%cl)
{	
	//Take server cmd / event permissions into account
		//Server cmds have their own security built into the functions, so no need to check for events

	switch$(%func)
	{
		case 0:
			%funcN = "Start";
			SERVERCMDPTGStart(%cl);
		case 1:
			%funcN = "Halt";
			SERVERCMDPTGHalt(%cl);
		case 2:
			%funcN = "Clear";
			SERVERCMDPTGClear(%cl,true);
		case 3:
			%funcN = "Clear-Save";
			SERVERCMDPTGClear(%cl,false);
		case 4:
			%funcN = "ClearAll";
			SERVERCMDPTGClearAll(%cl,true);
		case 5:
			%funcN = "ClearAll-Save";
			SERVERCMDPTGClearAll(%cl,false);
		case 6:
			%funcN = "Purge";
			SERVERCMDPTGPurge(%cl);
		case 7:
			%funcN = "ClearSeedSaves";
			SERVERCMDPTGClearAllSaves(%cl,"SeedSaves");
		case 8:
			%funcN = "ClearAllSaves";
			SERVERCMDPTGClearAllSaves(%cl,"AllSaves");
		case 9:
			%funcN = "SetAllStatic";
			SERVERCMDPTGAllStatic(%cl,true);
		case 10:
			%funcN = "SetAllNonStatic";
			SERVERCMDPTGAllStatic(%cl,false);
		case 11:
			%funcN = "SaveAll";
			SERVERCMDPTGSave(%cl);
		case 12:
			%funcN = "ShowHideChunks";
			SERVERCMDPTGReveal(%cl);
		default:
			PTG_MsgClient(%cl,"Failed","PTG: Action Failed","No valid function was defined.");
			return;
	}
	
	
	//Message host
	if(isObject(%cl))
	{
		%name = %cl.name;
		%id = %cl.bl_id;
	}
	else
	{
		%name = "Unknown";
		%id = "??????";
	}
	
	if(isObject(PTG_GlobalSO) && $PTG.allowEchos) 
		echo("\c4>>\c2P\c1T\c4G: \c0Player \c4\"" @ %name @ " (" @ %id @ ")\" \c0executed the \"" @ %funcN @ "\" function. \c4[EVENT] \c0->" SPC getWord(getDateTime(),1));
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


function fxDTSBrick::PTG_ChangeSeed(%brick,%seed,%bool,%cl)
{	
	//Make sure %seed is <= 8 digits
	
	if(isObject(PTG_MainSO))
	{
		//Set seed to either a random value or a custom value
		if(%bool)
			%seed = $PTGm.seed = getWord("- ",getRandom(0,1)) @ (getRandom(0,9999999) | 0); //random +/- 7 digit value (prevents scientific notation and other issues)
		else
			%seed = $PTGm.seed = getSubStr(%seed * 1,0,7); //*1 to filter out a string, if present (although should be auto-filtered by event)
	

		//Message host
		if(isObject(%cl))
		{
			%name = %cl.name;
			%id = %cl.bl_id;
		}
		else
		{
			%name = "Unknown";
			%id = "??????";
		}
		//if(%bool)
		//	%seed = "Random";
		
		messageAll('',"<font:Verdana Bold:" @ $PTG.fontSize @ ">\c0P\c3T\c1G: \c6Server seed changed to \"" @ %seed @ "\". <color:000000>[EVENT]");
		
		if(isObject(PTG_GlobalSO) && $PTG.allowEchos) 
			echo("\c4>>\c2P\c1T\c4G: \c0Player \c4\"" @ %name @ " (" @ %id @ ")\" \c0changed the generator seed to \"" @ %seed @ "\". \c4[EVENT] \c0->" SPC getWord(getDateTime(),1));
	}
	else
		PTG_MsgClient(%cl,"Failed","PTG: Action Failed","Main PTG script object not found; can't alter seed value. Please have the server host or a super admin apply their settings first.");
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


function fxDTSBrick::PTG_LoadPreset(%brick,%fpPreset,%clearFunc,%conds,%cl)
{
	//Admin only! (Depending on permissions set by host for events - either for PTG or in general)

	if(!isObject(%cl))
	{
		echo("\c2>>P\c1T\c4G \c2ERROR: \"PTG_LoadPreset\" event failed; client \"" @ %cl @ "\" not found! [!] \c0->" SPC getWord(getDateTime(),1));
		return;
	}
	if(!$PTG.allowNH_SrvrCmdEventUse && !PTG_HostCheck(%cl))
	{
		PTG_MsgClient(%cl,"Denied","PTG ERROR: Access Denied","The host has disabled non-host server command and event usage.");
		return;
	}
	if(!%cl.isAdmin)
	{
		PTG_MsgClient(%cl,"Denied","PTG ERROR: Access Denied","Only admins are allowed to load server presets.");
		return;
	}
	
	//Version check
	//if(%cl.PTGver != 3) //player using event doesn't need to have PTG downloaded
	//{
	//	PTG_MsgClient(%cl,"Denied","PTG ERROR: Access Denied","Version 3 of PTG is required, you don't appear to have it downloaded!");
	//	return;
	//}
	
	//Make sure Chunks BrickGroup exists
	if(!isObject(BrickGroup_Chunks))
	{
		%BGm = new SimGroup("BrickGroup_Chunks");
		mainBrickGroup.add(%BGm);
	}

	//Make sure necessary script / sim groups are set up
	if(!isObject(PTG_GlobalSO)) 
	{
		PTG_MsgClient(%cl,"Failed","PTG: Action Failed","No routine settings detected; please have the server host apply their routine settings to the server first.");
		return;
	}
	if(!isObject(PTG_MainSO))
	{
		PTG_MsgClient(%cl,"Failed","PTG: Action Failed","Main settings not detected; please have the server host or a super admin apply their settings to the server first.");
		return;
	}
	
	//////////////////////////////////////////////////
	
	%fpPreset = getSubStr(%fpPreset,0,30);
	%fpPreset = stripChars(%fpPreset,"\"");
	
	switch(%clearFunc)
	{
		case 0:
			%autoClearFunc = "None";
		case 1:
			%autoClearFunc = "Clear";
		case 2:
			%autoClearFunc = "Clear-Save";
		case 3:
			%autoClearFunc = "ClearAll";
		case 4:
			%autoClearFunc = "ClearAll-Save";
		case 5:
			%autoClearFunc = "Purge";
		default:
			%autoClearFunc = "";
	}
	
	%noFallDamage = mClamp(getWord(%conds,0),0,1);
	%autoHalt = mClamp(getWord(%conds,1),0,1);
	%autoReset = mClamp(getWord(%conds,2),0,1);
	%restart = mClamp(getWord(%conds,3),0,1);
	
	if(%restart)
		%pass = "Restart";
	else
		%pass = "Initialize";
	
	PTG_LoadServerPreset(%fpPreset,%noFallDamage,%autoHalt,%autoClearFunc,%autoReset,%pass);
	
	
	//Message host
	if(isObject(%cl))
	{
		%name = %cl.name;
		%id = %cl.bl_id;
	}
	else
	{
		%name = "Unknown";
		%id = "??????";
	}
	
	%fp = PTG_GetFP("ServerPresetFP","","","");
	%fpPresetRef = strReplace(%fpPreset,".txt","");
	%fpPresetRef = strReplace(%fpPresetRef,%fp,"");
	%fpPreset = %fpPresetRef;
					
	if(%fpPreset $= "" || %fpPreset $= " ")
		%fpPreset = "DEFAULT";
		
	if($PTG.allowEchos) 
		echo("\c4>>\c2P\c1T\c4G: \c0Player \c4\"" @ %name @ " (" @ %id @ ")\" \c0loaded the server preset \"" @ %fpPreset @ "\". \c4[EVENT] \c0->" SPC getWord(getDateTime(),1));
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


function fxDTSBrick::PTG_ShowPosition(%brick,%cl)
{
	//Take player permission for use of this server command into account
		//No need to message host when this event is called

	SERVERCMDPTGPos(%cl);
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


function fxDTSBrick::PTG_Condition(%brick,%condFunc,%cl)
{
	switch$(%condFunc)
	{
		case 0: //ifRunning
		
			if(isObject(PTG_GlobalSO) && $PTG.routine_Process $= "Gen")
				%brick.PTG_Event_Input(true,%cl);
			else
				%brick.PTG_Event_Input(false,%cl);
			
		case 1: //ifClearing
		
			if(isObject(PTG_GlobalSO) && $PTG.routine_Process $= "Clear")
				%brick.PTG_Event_Input(%brick,true,%cl);
			else
				%brick.PTG_Event_Input(%brick,false,%cl);
			
		case 2: //ifHalting
		
			if(isObject(PTG_GlobalSO) && $PTG.routine_isHalting)
				%brick.PTG_Event_Input(%brick,true,%cl);
			else
				%brick.PTG_Event_Input(%brick,false,%cl);
	}
}